#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <time.h>
#include <signal.h>
#include <dirent.h>


#define BUFSIZE 32768
#define VERSION "v.0.0.4"
#define AUTHOR "Written and copyrights by Mirko De Grandis."
#define KILO 1024
#define MEGA (1024*1024)
#define GIGA (1024*1024*1024)

#define PDEBUG 0


typedef struct{
  char* action;          //what the client wants
  char* what;            //what the action interest
  char* host;            //Host line
  char* agent;           //the client user-agent
  char* accept;          //accept line
  char* lang;            //accept-language line
  char* enc;             //accept-encoding line
  char* charset;         //accept-charset line
  char* keep;            //keep-alive line;
  char* conn;            //connection line;
}req_descriptor;



unsigned char ret_buf[BUFSIZE];
char * error_return = "<HTML>\n<BODY><p>File not found\n</BODY>\n</HTML>";
FILE *logfile;

int logflag=0;
int DEBUG=0;
int MYPORT=8000;    /* the port users will be connecting to */
time_t tempo;
int FORKON=8192;


char *mytime(struct tm *src);
void nop();
void read_file(req_descriptor *reqd, int num_buf,int *sock);
int shallIfork(char* filename);
char* nomefile(char *buf);
void send_dir_list(int sock, req_descriptor *reqd);
req_descriptor* parse_request(char *req); 
void rem_req_descriptor(req_descriptor *desc);
void init_req_descriptor(req_descriptor *desc);
char* get_op(char *buf);
char* gimme_line(char* buf,char* line);

void nop()
{
}

void init_req_descriptor(req_descriptor *desc)
{
  desc->action="";
  desc->what="";
  desc->host="";
  desc->agent="";
  desc->accept="";
  desc->lang="";
  desc->enc="";
  desc->charset="";
  desc->keep="";
  desc->conn="";
}

void rem_req_descriptor(req_descriptor *desc)
{
  free(desc->action);
  free(desc->what);
  free(desc->host);
  free(desc->agent);
  free(desc->accept);
  free(desc->lang);
  free(desc->enc);
  free(desc->charset);
  free(desc->keep);
  free(desc->conn);
  free(desc);
}

req_descriptor* parse_request(char *req)
{
  req_descriptor* ritorno;
  char reqcpy[1024];

  if( (ritorno=((req_descriptor *)malloc(sizeof(req_descriptor))))==NULL )
    {
      printf("Not enought memory!!!\n");
      exit(1);
    }
  else init_req_descriptor(ritorno);

  strcpy(reqcpy,req);
  ritorno->action=get_op(reqcpy);
  strcpy(reqcpy,req);
  ritorno->what=nomefile(reqcpy);
  strcpy(reqcpy,req);
  ritorno->host=gimme_line(reqcpy,"Host: ");
  strcpy(reqcpy,req);
  ritorno->agent=gimme_line(reqcpy,"User-Agent: "); 
  strcpy(reqcpy,req);
  ritorno->accept=gimme_line(reqcpy,"Accept: ");
  strcpy(reqcpy,req);
  ritorno->lang=gimme_line(reqcpy,"Accept-Language: ");
  strcpy(reqcpy,req);
  ritorno->enc=gimme_line(reqcpy,"Accept-Encoding: ");
  strcpy(reqcpy,req);
  ritorno->charset=gimme_line(reqcpy,"Accept-Charset: ");
  strcpy(reqcpy,req);
  ritorno->keep=gimme_line(reqcpy,"Keep-Alive: ");
  strcpy(reqcpy,req);
  ritorno->conn=gimme_line(reqcpy,"Connection: ");

  return ritorno;
}

char* gimme_line(char *buf,char *line)
{
  char *start,*end,*ritorno;
  if((ritorno=(char *)malloc(1024))==NULL)
    {
      printf("Not enough memory!\n");
      exit(1);
    }

  if(strstr(buf,line)==NULL) return NULL;

  start=(strstr(buf,line)+strlen(line));
  end=start;
  while(*end!='\n') end++;
  *end='\0';
  strcpy(ritorno,start);
  return ritorno;
}

int shallIfork(char* filename)
{
  int i;
  char buf[FORKON+1];
  FILE *f;

    if(PDEBUG) printf("Entrato in shallIfork()\n");

  f=fopen(filename,"r");
  if(f==NULL) return 0;
  if((i=fread(buf,1,FORKON+1,f))==FORKON+1) return 1;
  return 0;
}

char* nomefile(char *buf)
{
  char *cp, *cp2,*ritorno;
  int i;
    if(PDEBUG) printf("Entrato in nomefile()\n");

  cp=buf+5;
  cp2=strstr(cp," HTTP");
  if(cp2!=NULL) *cp2='\0';
  while(cp[0]=='.' || cp[0]=='/') 
    for(i=1;cp[i]!='\0';i++)
      { 
	cp[i-1]=cp[i];
	if(cp[i+1]=='\0') cp[i]='\0';
      }
  if((ritorno=(char *)malloc(1024))==NULL)
    {
      printf("Not enough memory!\n");
      exit(1);
    }
  strcpy(ritorno,cp);
  return ritorno;
}

char* get_op(char *buf)
{
  char* op;
   if((op=(char *)malloc(4))==NULL)
    {
      printf("Not enough memory!\n");
      exit(1);
    }
  strncpy(op,buf,3);
  op[3]='\0';
  return op;
}

void send_dir_list(int sock, req_descriptor *reqd)
{
  DIR *d;
  struct dirent *de;
  struct stat st;
  char dirslash[1024];
  char path[1024];
  char row[1024]; 
  char weight[80];
  char *dirname;
  char *spacesbuf;
  int spaces,i;
  int html=0;
  char *error1 = "Error listing directory\n";
  char *header =  "HTTP/1.1 200 OK\n"
    "Connection: close\n"
    "Content/Type: text/html\n\n";
  char *start_html = "<html><head><title>ls command output"
    "</title></head><body>"
    "<table border=\"0\"> ";
  char *end_html = "</table></body></html>";
  char *directory = "<IMG src=\"/data/directory.jpg\" height=16 width=16>";
  char *file = "<IMG src=\"/data/file.jpg\" height=16 width=16>";


  if((reqd->agent!=NULL) && (strstr(reqd->agent,"ozilla")!=NULL)) html=1;

  dirname=reqd->what;

  d = opendir(dirname);
  if(!d)
    {
      send(sock,error1,strlen(error1),0);
      if (DEBUG) printf("Error sending directory list\n");
      if(logflag)
	{
	  time(&tempo);
	  fprintf(logfile,"%s Error sending directory list\n", mytime(localtime(&tempo)));
	}
      return;
    }
  
  strcpy(dirslash,dirname);			// add final / if needed
  if(dirslash[strlen(dirslash)-1] != '/')
    strcat(dirslash,"/");
  
  if(html)
    {
      send(sock,header,strlen(header),0);
      send(sock,start_html,strlen(start_html),0);
    }

  while((de = readdir(d)))
    {		// read all dirents
      if(de->d_name[0] == '.')	// doesn't show hidden files
	continue;
      strcpy(path,dirslash);
      strcat(path,de->d_name);
      stat(path,&st);

      if((int)st.st_size>=GIGA) 
	sprintf(weight,"%.2lf %s",(double)st.st_size/GIGA,"Gbytes");
      else if((int)st.st_size>=MEGA) 
	sprintf(weight,"%.2lf %s",(double)st.st_size/MEGA,"Mbytes");
      else  if((int)st.st_size>=KILO) 
	sprintf(weight,"%.2lf %s",(double)st.st_size/KILO,"Kbytes");
      else sprintf(weight,"%d %s",(int)st.st_size,"bytes");

      if(html)
	{ 
	  sprintf(row,"<tr><td>%s</td><td>%s</td><td>%s</td></tr>\n\r",S_ISDIR(st.st_mode)? directory:file,de->d_name,weight); 
	}
      else 
	{
	  spaces=60-strlen(de->d_name);
	  if(spaces<0) spaces=1;
	  if((spacesbuf=(char *)malloc(spaces))==NULL)
	    {
	      printf("Not enough memory!\n");
	      exit(1);
	    }
	  for(i=0;i<spaces-1;i++) spacesbuf[i]=' ';
	  spacesbuf[spaces-1]='\0';
	  sprintf(row,"%s%s%s\n",de->d_name,spacesbuf,weight);
	  free(spacesbuf);
	}
      send(sock,row,strlen(row),0); // send a row (a file)
    }
  
  if(html) send(sock,end_html,strlen(end_html),0);
  closedir(d);

  if (DEBUG) printf("Directory list sent successfully\n");
  
  if(logflag)
    {
      time(&tempo);
      fprintf(logfile,"%s Directory list sent successfully\n",mytime(localtime(&tempo)));
    }
}

void read_file(req_descriptor *reqd, int num_buf,int *sock)
{
  int i,j,totalBytes,bytesSent,totalSent,size,times;
  char str[80],str2[80];
  FILE *f;

  f=NULL;

  if(PDEBUG) printf("Entrato in read_file()\n");

  if(DEBUG) printf("file: |%s|\n",reqd->what);

  if(logflag)
    { 
      time(&tempo);
      fprintf(logfile,"%s file: |%s|\n",mytime(localtime(&tempo)),reqd->what);
    }

  if(!strcmp(reqd->what,"")||reqd->what[strlen(reqd->what)-1]=='/')
    { 
      strcpy(str,reqd->what);
      strcat(str,"index.htm");
      strcpy(str2,str);
      strcat(str2,"l");
      
      (f=fopen(str,"r"))||(f=fopen(str2,"r"));
      if(DEBUG) printf("invio pagina di default\n");
      if(logflag)
	{
	  time(&tempo);
	  fprintf(logfile,"%s invio pagina di default\n",mytime(localtime(&tempo)));
	}
    }
  else f=fopen(reqd->what,"r");

  if(f==NULL) 
    {
      if(DEBUG) perror(reqd->what);
      bytesSent=send(*sock,error_return,strlen(error_return),0);
      return;
    }

  if(strstr(reqd->what,".mp3")||strstr(reqd->what,".MP3"))
  {
    bytesSent=send(*sock,"ICY 200 OK",strlen("ICY 200 OK"),0);
    bytesSent=send(*sock,"icy-metaint:?????",strlen("icy-metaint:?????"),0);
  }  

  //  if(strstr(reqd->agent,"Wget")!=NULL) //per quando avro' capito cosa vuole wget
  //    {
  //            bytesSent=send(*sock,"HTTP/1.1 200 OK\n",strlen("HTTP/1.1 200 OK\n"),0);
  //            bytesSent=send(*sock,"Content-Length: 2 bytes\n Content-Type: */*\n Location: \n Last-Modified: ????\n Set-Cookie: name=\"bo\";information=\"bo\";host=\"mine\";path=\"/\";secure=\"no\";expires=\"never\"\n WWW-Authenticate: no\n Accept-Ranges: none\n Content-Range: 2 bytes\n Keep-Alive: 200\n Connection: Keep-Alive\n",strlen("Content-Length: 2 bytes\n Content-Type: */*\n Location: \n Last-Modified: ????\n Set-Cookie: name=\"bo\";information=\"bo\";host=\"mine\";path=\"/\";secure=\"no\";expires=\"never\"\n WWW-Authenticate: no\n Accept-Ranges: none\n Content-Range: 2 bytes\n Keep-Alive: 200\n Connection: Keep-Alive\n"),0);
  //    }

  for(j=0;j<BUFSIZE;j++)ret_buf[j]='\0';
  totalBytes=0;
  times=0;

  while(!feof(f))
    { 
      times++;
      i=fread(ret_buf,1,BUFSIZE,f);
      if(DEBUG) printf("[%d]in read_file(PID:%d),while(!feof(f))=>i:%d\n",times,getpid(),i);
      if(logflag)
	{ 
	  time(&tempo);
	  fprintf(logfile,"%s [%d]in read_file(PID:%d),while(!feof(f))=>i:%d\n",mytime(localtime(&tempo)),times,getpid(),i);	  
	  if(times%10==0) fflush(logfile);
	}

      if(i==0) 
	{
	  fclose(f); 
	  bytesSent=send(*sock,error_return,strlen(error_return),0); 
	  return;
	}
      size=i;
      totalSent=0;
      do
	{
	  bytesSent=send(*sock,ret_buf+totalSent,i-=totalSent,0);
	  if(bytesSent==-1) {fclose(f);return;}
	  totalSent+=bytesSent;
	}while(totalSent<size);
      totalBytes+=totalSent;
    }
  if(DEBUG) printf("%d bytes read from file %s,in %d times\n",totalBytes,reqd->what,times);
  if(logflag) 
    {
      time(&tempo);
      fprintf(logfile,"%s %d bytes read from file %s,in %d times\n",mytime(localtime(&tempo)),totalBytes,reqd->what,times);
      fflush(logfile);
    }
  fclose(f);
}

int main(int argc, char *argv[],char *envp[])
{
  int i,j,totalReceived;
  char recvBuffer[BUFSIZE];
  int sock,tmp_porta,tmp_forkon;
  int serverSocket;
  struct sockaddr_in serverAddr;
  struct sockaddr_in clientAddr;
  int clientAddrSize;
  struct hostent* entity;
  struct sigaction sa_dontcare;
  int childPID;
  char *str,*cp,*cp2,arg[80];
  int error;
  req_descriptor *conn_req;

  error=0;

  for(j=1;j<argc;j++)
    {
      if(!strcmp(argv[j],"-log"))
	{ 
	  logflag=1;
	  logfile=fopen("logfile.log","a+");
	  if(logfile==NULL) logflag=0;
	}
      else if(!strcmp(argv[j],"-debug"))
	{
	  DEBUG=1;
	}
      else if(strstr(argv[j],"-port:"))
      {
	str=strstr(argv[j],"-port:");
	str=str+6;
	tmp_porta=0;
	while(*str!='\0')
	  {
	    tmp_porta=tmp_porta*10+(int)(str[0]-'0');
	    str++;
	  }
	if(tmp_porta<=1024) tmp_porta=8000;
	if(DEBUG) printf("MYPORT:%d\n\n",tmp_porta);
	MYPORT=tmp_porta;
      }
      else if(strstr(argv[j],"-forkon:"))
      {
	str=strstr(argv[j],"-forkon:");
	str=str+8;
	tmp_forkon=0;
	while(*str!='\0')
	  {
	    tmp_forkon=tmp_forkon*10+(int)(str[0]-'0');
	    str++;
	  }
	if(DEBUG) printf("FORKON:%d\n\n",tmp_forkon);
	FORKON=tmp_forkon;
      }
      else if(!strcmp(argv[j],"--help")||!strcmp(argv[j],"-h"))
	{
	  printf("%s (%s) %s\n",argv[0],VERSION,AUTHOR);
	  printf("Usage: %s [OPTIONS]\n",argv[0]);
	  printf("OPTIONS are:\n\n");
	  printf("-log\t\t\tEnables log mode\n");
	  printf("-debug\t\t\tEnables debug mode\n");
	  printf("-port:<PORT_NUMBER>\tSet the port users will be connecting to. default is 8000\n");
	  printf("-forkon:<BYTES>\t\tSet the max dimension for the files on which the program don't need to fork (set 0 to fork always). default is 8192\n\n");
	  exit(0);
	}
      else
	{
	  printf("Unrecognized option!! %s\n",argv[j]);
	  error=1;
	}
    }
  
  if(error!=0)
    { 
      printf("Exit()\n");
      exit(0);
    }

  serverSocket=socket(AF_INET,SOCK_STREAM,0);
  serverAddr.sin_family=AF_INET;
  serverAddr.sin_port=htons(MYPORT);
  serverAddr.sin_addr.s_addr=INADDR_ANY;
  memset(&(serverAddr.sin_zero),0,8);

  bind(serverSocket,(struct sockaddr*)&serverAddr,sizeof(struct sockaddr));

  time(&tempo);
  printf("%s",mytime(localtime(&tempo)));
  printf("\n\t\t(l:%d,d:%d) %s (%s): ready to send!! :)\n\n",logflag,DEBUG,argv[0],VERSION);

  listen(serverSocket,10);
  while(1)
    {
      clientAddrSize=sizeof(struct sockaddr_in);
      do
	{
	  sock=accept(serverSocket,(struct sockaddr*) &clientAddr,&clientAddrSize);
	}while ((sock==-1) && (errno==EINTR));
      if(sock==-1)
	{
	  printf("Bad accept\n");
	  exit(1);
	}
      entity=gethostbyaddr((char*) &clientAddr.sin_addr,sizeof(struct in_addr),AF_INET);

      if(DEBUG) printf("-------------------------\n");
      if(DEBUG) printf("Connection from %s\n",inet_ntoa((struct in_addr) clientAddr.sin_addr));

      if(logflag)
	{
	  time(&tempo);
	  fprintf(logfile,"%s -------------------------\n",mytime(localtime(&tempo)));
	}
      if(logflag) 
	{
	  time(&tempo);
	  fprintf(logfile,"%s Connection from %s\n",mytime(localtime(&tempo)),inet_ntoa((struct in_addr) clientAddr.sin_addr));
	}
      i=recv(sock,recvBuffer,BUFSIZE,0);

      if(PDEBUG) printf("i:%d\n",i);

      if(i==-1) break;
      /*if(recvBuffer[i-1]!='\n') break;*/

      recvBuffer[i]='\0';

      if(DEBUG) printf("Received from client: \n*****\n%s\n*****\n",recvBuffer);
      if(logflag) 
	{
	  time(&tempo);
	  fprintf(logfile,"%s Received from client: \n*****\n%s\n*****\n",mytime(localtime(&tempo)),recvBuffer);
	  fflush(logfile);
	}
      totalReceived=0;

      conn_req=parse_request(recvBuffer);

      if(((cp2=strstr((cp=conn_req->what),"cmd:ls"))!=NULL||
	  (cp2=strstr((cp=conn_req->what),"cmd%3Als"))!=NULL)||
	  (cp2=strstr((cp=conn_req->what),"cmd_ls"))!=NULL)
	{
	  *cp2='\0';
	  strcpy(arg,cp);
	  if(!strcmp(arg,"")) strcpy(arg,".");
       	  if(DEBUG) printf("Request list:%s\n",arg);

	  if(logflag)
	    {
	      time(&tempo);
	      fprintf(logfile,"%s Request list:%s\n",mytime(localtime(&tempo)),arg);
	      fflush(logfile);
	    }

	  strcpy(conn_req->what,arg);
	  send_dir_list(sock,conn_req);
	  close(sock);
	  if(DEBUG) printf("Connection closed by client.\n");
	} //inserire comandi????
      else
	{  
	if(shallIfork(nomefile(recvBuffer))) 
	{
	  if(DEBUG) printf("devo forkare, nome file:%s\n",nomefile(recvBuffer));

	  if(logflag)
	    { 
	      time(&tempo);
	      fprintf(logfile,"%s devo forkare, nome file:%s\n",mytime(localtime(&tempo)),nomefile(recvBuffer));
	    }

	  childPID=fork();
	  if(childPID==0) 
	    {
	      if(DEBUG) printf("Parent: PID %d, Child: PID %d\n",getppid(),getpid());
	      if(logflag)
		{ 
		  time(&tempo);
		  fprintf(logfile,"%s Parent: PID %d, Child: PID %d\n",mytime(localtime(&tempo)),getppid(),getpid());
		}

	      read_file(conn_req,totalReceived,&sock);
	      close(sock);
	      if(DEBUG) printf("Connection closed by client.\n");
	      if(logflag)
		{ 
		  time(&tempo);
		  fprintf(logfile,"%s Connection closed by client.\n",mytime(localtime(&tempo)));
		  fflush(logfile);
		}
	      exit(0);
	    }
	  else
	    { 
	      close(sock);  
	      if(DEBUG) printf("Sending in background....\n");
	      if(logflag)
		{ 
		  time(&tempo);
		  fprintf(logfile,"%s Sending in background....\n",mytime(localtime(&tempo)));
		  fflush(logfile);
		}
	      sa_dontcare.sa_handler=SIG_IGN;      /*per non lasciare troppi processi zombie*/
	      sa_dontcare.sa_flags=SA_NOCLDSTOP;   /*idem*/
	      sigaction(SIGCHLD,&sa_dontcare,NULL);/*idem*/
	    }
	}
	else 
	  {
	    if(DEBUG) printf("non devo forkare, PID:%d\n",getpid());
	    if(logflag)
	      {
		time(&tempo);
		fprintf(logfile,"%s non devo forkare, PID:%d\n",mytime(localtime(&tempo)),getpid());
	      }
	    read_file(conn_req,totalReceived,&sock);
	    close(sock);
	    if(DEBUG) printf("Connection closed by client.\n");
	    if(logflag)
	      { 
		time(&tempo);
		fprintf(logfile,"%s Connection closed by client.\n",mytime(localtime(&tempo)));
		fflush(logfile);
	      }
	  }
	}
      rem_req_descriptor(conn_req);
    }
  return 0;
}


char *mytime(struct tm *src)
{
  char *str;
  char day[4];
  char mon[4];

                      /*
	              struct tm {
                      int     tm_sec;          seconds 
                      int     tm_min;          minutes
                      int     tm_hour;         hours 
                      int     tm_mday;         day of the month 
                      int     tm_mon;          month 
                      int     tm_year;         year 
                      int     tm_wday;         day of the week 
                      int     tm_yday;         day in the year 
                      int     tm_isdst;        daylight saving time 
		      };*/

  if(PDEBUG) printf("Entrato in mytime()\n");
  switch(src->tm_wday)
    {
    case 0:
      strcpy(day,"Sun");
      break;
    case 1:
      strcpy(day,"Mon");
      break;
    case 2:
      strcpy(day,"Tue");
      break;
    case 3:
      strcpy(day,"Wed");
      break;
    case 4:
      strcpy(day,"Thu");
      break;
    case 5:
      strcpy(day,"Fri");
      break;
    case 6:
      strcpy(day,"Sat");
      break;
    }

  switch(src->tm_mon)
    {
    case 0:
      strcpy(mon,"Jan");
      break;
    case 1:
      strcpy(mon,"Feb");
      break;
    case 2:
      strcpy(mon,"Mar");
      break;
    case 3:
      strcpy(mon,"Apr");
      break;
    case 4:
      strcpy(mon,"May");
      break;
    case 5:
      strcpy(mon,"Jun");
      break;
    case 6:
      strcpy(mon,"Jul");
      break;
    case 7:
      strcpy(mon,"Aug");
      break;
    case 8:
      strcpy(mon,"Sep");
      break;
    case 9:
      strcpy(mon,"Oct");
      break;
    case 10:
      strcpy(mon,"Nov");
      break;
    case 11:
      strcpy(mon,"Dec");
      break;
    }

  str=malloc(30);
  sprintf(str,"%s %s %02d %02d:%02d:%02d %d%c",day,mon,src->tm_mday,src->tm_hour,src->tm_min,src->tm_sec,1900+src->tm_year,'\0');
  return str;
}
